From 2c357867f3dd41aa618ca7cc8e493223b3581c41 Mon Sep 17 00:00:00 2001
From: Jiajie Li <lijiajie11@huawei.com>
Date: Tue, 8 Dec 2020 19:11:37 +0800
Subject: [PATCH] arch/aarch64/arch_parse: improve VAR_CBLOCK start indentify

The real problem with arm gensrc is .set pseudoinstruction separate the
.rodata / .rodata.* / .bss / .data.* such section start identifier with
follow var_cblock. So instead of handle the section start identifier
one by one, we should solve the root problem with the additional
judge of .set pseudoinstruction  in is_variable_start function.

Change-Id: I3cfde781358d347ce0f05791bd74c6fb7c56947b
Signed-off-by: imxcc <xingchaochao@huawei.com>
---
 libcare.spec                  |  5 ++++-
 src/arch/aarch64/arch_parse.c | 15 ++++++---------
 2 files changed, 10 insertions(+), 10 deletions(-)

diff --git a/libcare.spec b/libcare.spec
index aaaccf0..5e7e5c5 100644
--- a/libcare.spec
+++ b/libcare.spec
@@ -1,7 +1,7 @@
 Version: 0.1.4
 Name: libcare
 Summary: LibCare tools
-Release: 13%{?dist}
+Release: 14%{?dist}
 Group: Applications/System
 License: GPLv2
 Url: http://www.cloudlinux.com
@@ -158,6 +158,9 @@ exit 0
 %endif
 
 %changelog
+* Thu Sep 23 2021 Jiajie Li <lijiajie11@huawei.com> - 0.1.4-14
+- arch/aarch64/arch_parse: improve VAR_CBLOCK start indentify
+
 * Thu Sep 23 2021 Jiajie Li <lijiajie11@huawei.com> - 0.1.4-13
 - arch/aarch64/arch_elf: Add LDR and B instruction relocation
 
diff --git a/src/arch/aarch64/arch_parse.c b/src/arch/aarch64/arch_parse.c
index 36945b9..a0d5979 100644
--- a/src/arch/aarch64/arch_parse.c
+++ b/src/arch/aarch64/arch_parse.c
@@ -131,22 +131,19 @@ int is_variable_start(struct kp_file *f, int l, int *e, int *pglobl, kpstr_t *nm
 			case DIRECTIVE_TEXT:
 			case DIRECTIVE_DATA:
 			case DIRECTIVE_BSS:
+			case DIRECTIVE_SECTION:
 			case DIRECTIVE_PUSHSECTION:
 			case DIRECTIVE_POPSECTION:
 			case DIRECTIVE_PREVIOUS:
 			case DIRECTIVE_SUBSECTION:
 				break;
-			case DIRECTIVE_SECTION:
-				if (nm2.s != NULL)
-					break;
+			case DIRECTIVE_SET:
 				get_token(&s, &nm2);
 				get_token(&s, &nm2);
-				if (kpstrcmpz(&nm2, ".rodata") == 0) {
-					*nm = nm2;
-					if(e)
-						*e = l + 2;
-					return 1;
-				}
+				*nm = nm2;
+				if (e)
+					*e = l + 1;
+				return 1;
 			case DIRECTIVE_TYPE:
 				get_type_args(cline(f, l), &nm2, &attr);
 				if (kpstrcmpz(&attr, "%object") && kpstrcmpz(&attr, "%tls_object"))
-- 
2.19.1

